
////////////////////////////////////////////////////////////////////////////
// for specification of CPU

#include <setjmp.h>
#include <signal.h>
#include "cpu_x86.h"

#ifdef WIN32
	#include <windows.h>
#endif

static jmp_buf jmpPtr;

static void SSE_not_support(int sig)
{
	signal(SIGILL, SIG_DFL);
	longjmp(jmpPtr, 1);
}

int haveUNITa(void); /* defined in cpua.nas */
void setPIII_round(void);

int haveX86_UNIT(void)
{
	static int unit = -1;

	if (unit != -1) return unit;
	unit = haveUNITa();

#if defined(WIN32) && defined(HAVE___TRY) && defined(HAVE_EXCEPTION_EXECUTE_HANDLER) 
	if (unit & MU_tSSE) {
		__try {
			setPIII_round();
		}
		__except(EXCEPTION_EXECUTE_HANDLER) {
			unit &= ~(MU_tSSE|MU_tSSE2);
		}
	}
#elif defined(__unix__) || defined(WIN32) || defined(__os2__) || defined(__dos__)
	if (unit & MU_tSSE) {
		int ret;
		ret = setjmp(jmpPtr);
		if (!ret) {
			signal(SIGILL, SSE_not_support);
			setPIII_round();
			signal(SIGILL, SIG_DFL);
		}else{
			unit &= ~(MU_tSSE|MU_tSSE2);
		}
	}
#else
	if(unit & MU_tSSE) setPIII_round();
#endif

	return unit;
}
