/**
@author d
@file dkcMTRand32.h
@brief Mersenne Twister algorithm wrapper on 32bit
@since 2006/01/18
*/

#ifndef DKUTIL_C_MT_RAND32_H
#define DKUTIL_C_MT_RAND32_H

#ifdef INDEPENDENT_DKC_MT
#	include "define.h"
#else
#	include <dkutil_c/dkutil_cstd/define.h>
#endif
#include <stdio.h>

#define dkcdMT_RAND32_N 624
typedef struct dkc_Mersenne_Twister_32bit{
	/** The array for the state vector */
	uint32 state[dkcdMT_RAND32_N];
	uint32 output[dkcdMT_RAND32_N];
	uint32 index;
	char *mallocPtr;
	void *function_ptr;
}DKC_MT_RAND32;

typedef DKC_MT_RAND32 myMT_t;



DKC_EXTERN DKC_MT_RAND32 *WINAPI dkcAllocMTRand32(uint32 seed);

DKC_EXTERN int WINAPI dkcFreeMTRand32(DKC_MT_RAND32 **p);


/**
@warning KdkcAllocMTRand32()Ŋmۂ̈ĂB
*/
DKC_EXTERN void WINAPI dkcMTRand32Init(DKC_MT_RAND32 *p,uint32 seed);
/**
@warning KdkcAllocMTRand32()Ŋmۂ̈ĂB
*/
DKC_EXTERN void WINAPI 
	dkcMTRand32InitByArray(DKC_MT_RAND32 *p,uint32 *init_key,int32 key_length);


DKC_EXTERN uint32 WINAPI dkcMTRand32Get(DKC_MT_RAND32 *p);


typedef void (*DKC_MT_RAND32_GENERATE_F_TYPE)(	DKC_MT_RAND32 * );
DKC_EXTERN void dkcMTRand32Next_C(DKC_MT_RAND32 *p);
DKC_EXTERN void dkcMTRand32Next_MMX(DKC_MT_RAND32 *p);
DKC_EXTERN void dkcMTRand32Next_SSE2(DKC_MT_RAND32 *p);


/**

@warning SSE2MMXgpłȂdkcMTRand32Next_SSE2()dkcMTRand32Next_MMX()Ă͂ȂB
*/
///֐B
DKC_INLINE void 
	dkcMTRand32SetNextFunction(DKC_MT_RAND32 *p,DKC_MT_RAND32_GENERATE_F_TYPE f)
{
	p->function_ptr = f;
}

DKC_INLINE uint32 dkcMTRand32Get_INL(DKC_MT_RAND32 *p){
	if(p->index >= dkcdMT_RAND32_N){
		DKC_MT_RAND32_GENERATE_F_TYPE pf;
		pf = p->function_ptr;
		pf(p);
	}
	return p->output[p->index++];
}



/* generates a random number on [0,0x7fffffff]-interval */
DKC_INLINE long dkcMTRand32Get_int31(DKC_MT_RAND32 *p)
{
    return (long)(dkcMTRand32Get_INL(p)>>1);
}

/* generates a random number on [0,1]-real-interval */
DKC_INLINE double dkcMTRand32Get_real1(DKC_MT_RAND32 *p)
{
    return dkcMTRand32Get_INL(p)*(1.0/4294967295.0); 
    /* divided by 2^32-1 */ 
}

/* generates a random number on [0,1)-real-interval */
DKC_INLINE double dkcMTRand32Get_real2(DKC_MT_RAND32 *p)
{
    return dkcMTRand32Get_INL(p)*(1.0/4294967296.0); 
    /* divided by 2^32 */
}

/* generates a random number on (0,1)-real-interval */
DKC_INLINE double dkcMTRand32Get_real3(DKC_MT_RAND32 *p)
{
    return (((double)dkcMTRand32Get_INL(p)) + 0.5)*(1.0/4294967296.0); 
    /* divided by 2^32 */
}

/* generates a random number on [0,1) with 53-bit resolution*/
DKC_INLINE double dkcMTRand32Get_res53(DKC_MT_RAND32 *p) 
{ 
    unsigned long a=dkcMTRand32Get_INL(p)>>5;
		unsigned long b=dkcMTRand32Get_INL(p)>>6; 
    return(a*67108864.0+b)*(1.0/9007199254740992.0); 
} 







#endif



